/* Definicoes basicas */



// TIPOS

// inteiro sem sinal de 8 bits
#define BYTE unsigned char

// inteiros de 32 bits
#define UINT unsigned int
#define INT  int

// inteiros de 16 bits
#define UINT16 unsigned short int
#define INT16  short int

// booleano
#define BOOL unsigned char
#define TRUE 1
#define FALSE 0



// MENSAGENS

#define MSG_SEMMEMORIA "\nImpossivel alocar memoria, memoria esgotada."
#define MSG_IMPOSSIVELEXECUTAR "\nImpossivel executar aplicativo."
#define MSG_ERROABRIRARQUIVO "\nImpossivel abrir arquivo %s."
#define MSG_ERROLETKARQUIVO "\nErro ao ler token do arquivo %s."
#define MSG_ERROCOMENTARIOABERTO " Erro causado possivemente por \
comentario aberto sem ser fechado. Havia(m) %u comentario(s) aberto(s) quando \
ocorreu o erro."
#define MSG_AVISOFIMCOMENTO "Encontrado fim de comentario sem o seu respectivo \
inicio, ignorado."
#define MSG_ERROFIMARQUIVO " Encontrado o fim do arquivo inesperadamente."
#define MSG_TEMPO "\nTempo: %f segundos. Frames: %u. Frames por segundo: %f\n"
#define MSG_TITULO "Exibe solidos. Requer arquivo de solido (*.S) e de particao (*.PAR)."
#define MSG_INSTRUCOES "\n\nUse: apl arquivo,              sem a extensao.\n"



// VIDEO, VIEWPORT, DIMENSOES DE ESTRUTURAS DE DADOS, HARDWARE

// modos de video
// MCGA: 320x200x256 (modo grafico default)
#define MCGA  0x0013
// texto comum
#define TEXTO 0x0003

// resolucao de video no modo grafico
#define RESX 320
#define RESY 200

// meio da tela
// ( RESX >> 1 )
#define RESX2 160
// ( RESY >> 1 )
#define RESY2 100

// valores maximos e minimos para coordenadas no video (modo grafico default)
#define MINX 0
#define MINY 0
// MAXX ( RESX - 1 )
#define MAXX 319
// MAXY ( RESY - 1 )
#define MAXY 199

// tamanho a memoria virtual de video, ( RESX * RESY )
#define TAMVR 64000
// um quarto do tamanho da memoria virtual de video, ( RESX * RESY ) >> 2
#define TAMVR4 16000

// numero de entradas da pallete para tons de uma cor
#define NUMCOR 32
// valor basico do RGB das cores na pallete (+- ajusta luz ambiente)
#define ILUMAMB 25



// MATEMATICA, TRANSFORMACOES, COORDENADAS VIRTUAIS

// numero PI
#define Pi 3.14159265359

// angulos, NANGS,...
// numero de unidades para completar uma volta (em graus seria 360)
#define NANGS 256
// numero de unidades para completar meia volta (graus seria 180), NANGS / 2
#define NANGS2 128
// numero de unidades para completar 1/4 de volta (em graus: 90), NANGS >> 2
#define NANGS4 64
// numero maximo que as unidades para completar uma volta, NANGS - 1
#define MAXANGS 255

// limites para valores virtuais
// valor maximo e minimo para Z
#define MAXZ 10000
#define MINZ -10000
// limite de visibilidade (de acordo com Z), para iluminacao por Z
#define FIMIZ 200

// centro de projecao para projecao perspectiva e recorte em Z
// distancia do centro de projecao ateh o plano de projecao
#define DISTCP 300
// - ( DISTCP - 2 )
#define RECZ -298

// calcula o modulo (comprimento) de um vetor
#define MODULO(X, Y, Z) ( (float) sqrt ( ( X ) * ( X ) + ( Y ) * ( Y ) + ( Z ) * ( Z ) ) )



// PREDECLARACOES DE CLASSES

class CSolido;
class CArquivo;
class CUniverso;